package cn.com.infosec.asn1;

import java.io.InputStream;
import java.io.OutputStream;

public class BERGenerator extends ASN1Generator {
   private boolean _tagged = false;
   private boolean _isExplicit;
   private int _tagNo;

   protected BERGenerator(OutputStream out) {
      super(out);
   }

   public BERGenerator(OutputStream out, int tagNo, boolean isExplicit) {
      super(out);
      this._tagged = true;
      this._isExplicit = isExplicit;
      this._tagNo = tagNo;
   }

   private void writeHdr(int tag) {
      super._out.write(tag);
      super._out.write(128);
   }

   public OutputStream getRawOutputStream() {
      return super._out;
   }

   protected void writeBERHeader(int tag) {
      if (this._tagged) {
         int var2 = this._tagNo | 128;
         if (this._isExplicit) {
            this.writeHdr(var2 | 32);
            this.writeHdr(tag);
         } else if ((tag & 32) != 0) {
            this.writeHdr(var2 | 32);
         } else {
            this.writeHdr(var2);
         }
      } else {
         this.writeHdr(tag);
      }

   }

   protected void writeBERBody(InputStream contentStream) {
      int var2;
      while((var2 = contentStream.read()) >= 0) {
         super._out.write(var2);
      }

   }

   protected void writeBEREnd() {
      super._out.write(0);
      super._out.write(0);
      if (this._tagged && this._isExplicit) {
         super._out.write(0);
         super._out.write(0);
      }

   }
}
